<template>
  <div class="login">
    <h2 class="title">Login</h2>
    <social-auth/>
    <form class="login__form" @submit.prevent="login">

      <!-- Email -->
      <v-input  name="Email"
                type="email"
                v-model="user.email"
                @change="updateUserEmail"
                :isError="$v.user.email.$error">
        <template slot="error">
          <div class="error" v-if="!$v.user.email.required">Field is required</div>
        </template>
      </v-input>

      <!-- pass -->
      <v-input  name="Password"
                :type="typePassword"
                v-model="user.password"
                @change="updateUserPassword"
                :isError="$v.user.password.$error">
        <template slot="optional">
          <button class="btn btn--empty" type="button" name="showPass" @click="showPass = !showPass">
            <img width="20" src="@/assets/img/svg/eye.svg" alt="eye" v-if="showPass">
            <img width="20" src="@/assets/img/svg/hide.svg" alt="eye" v-else>
          </button>
        </template>
        <template slot="error">
          <div class="error" v-if="!$v.user.password.required">Field is required</div>
        </template>
      </v-input>

      <!-- buttons -->
      <div class="login__btn-wrapper">
        <button class="btn btn--withBtn" type="submit" name="login">
          Log in
          <span class="btn-in-btn">
            <img src="@/assets/img/svg/triangle.svg" alt="Arrow">
          </span>
        </button>
        <button class="btn btn--ghostOrange" type="button" name="Reset password" @click="goToResetPassword">
          Reset password
        </button>
      </div>
    </form>
  </div>
</template>

<script>
import SocialAuth from '@/components/Authorization/SocialAuth';
import Input from '@/components/Input';
import {required} from 'vuelidate/lib/validators';
import {mapActions, mapMutations} from 'vuex';
const touchMap = new WeakMap();

export default {
  name: 'Log',
  data() {
    return {
      user: {
        email: '',
        password: ''
      },
      showPass: false
    }
  },
  validations: {
    user: {
      email: {
        required
      },
      password: {
        required
      }
    }
  },
  components:{
    'social-auth': SocialAuth,
    'v-input': Input
  },
  methods: {
    ...mapActions(['USER_LOGIN']),
    ...mapMutations(['UPDATE_AUTH_COMPONENT']),
    updateUserEmail(val) {
      this.delayTouch(this.$v.user.email);
      this.user.email = val;
    },
    updateUserPassword(val) {
      this.delayTouch(this.$v.user.password);
      this.user.password = val;
    },
    login() {
      let disabled = false;
      this.$v.user.email.$touch();
      this.$v.user.password.$touch();
      if (this.$v.user.email.$error || this.$v.user.password.$error) {
        return 0;
      }
      const params = {
        usernameOrEmail: this.user.email,
        password: this.user.password
      };
      if(!disabled) {
        disabled = true;
        this.USER_LOGIN(params)
          .then(() => {
            this.$router.push('/account');
            this.UPDATE_AUTH_COMPONENT({isShown: false});
          })
          .catch((err) => {
            const message = err.desc || JSON.stringify(err);
            this.$notify({
              group: 'app',
              type:'error',
              text: message
            });
            console.error(`EM LogIn Error: ${message}`);
          })
          .finally(() => {
            disabled = false;
          });
      }
    },
    goToResetPassword() {
      this.UPDATE_AUTH_COMPONENT({name: 'ResetPass', isShown: true});
    },
    delayTouch($v) {
      $v.$reset();
      if (touchMap.has($v)) {
        clearTimeout(touchMap.get($v));
      }
      touchMap.set($v, setTimeout($v.$touch, 1000));
    }
  },
  computed: {
    typePassword() {
      return (this.showPass) ? 'text' : 'password';
    }
  }
}
</script>

<style lang="sass" scoped>
.title
  font-family: $mainFont
  font-size: rem(32)
  line-height: 1.2
  margin: rem(70) 0 rem(36)
  text-align: left
.login
  &__form
    margin-top: rem(50)
    .input
      margin-top: rem(36)
  &__btn-wrapper
    display: flex
    flex-direction: row
    margin-top: rem(26)
    .btn
      margin-right: rem(20)
</style>
